package bookmark;

import java.util.Iterator;
import java.util.Map;

import com.opensymphony.xwork.ActionContext;
import com.opensymphony.xwork.ActionSupport;
import com.opensymphony.xwork.ModelDriven;

/** ubN}[N̒ǉEҏWȂ܂ */
public class EditAction extends ActionSupport implements ModelDriven {

	/** ubN}[N */
	private Bookmark bookmark = new Bookmark();
	public Object getModel() { return bookmark; };

	/** ҏWʕ\ */
	public String newDisplay() throws Exception {
		return INPUT;
	}

	/** ҏWʕ\ */
	public String editDisplay() throws Exception {
		Map session = ActionContext.getContext().getSession();
		Map registry = (Map) session.get("registry");
		
		for (Iterator iter = registry.keySet().iterator(); iter.hasNext();) {
			System.out.println(iter.next());			
		}
		
		Bookmark target = (Bookmark) registry.get(bookmark.getTitle());
		if (target != null) {
			bookmark = target;
		}
		return INPUT;
	}

	/** ubN}[N̒ǉs܂ */
	public String execute() throws Exception {
		Map session = ActionContext.getContext().getSession();
		Map registry = (Map) session.get("registry");
		registry.put(bookmark.getTitle(), bookmark);
		return SUCCESS;
	}

	/** ̓`FbN */
	public void validate() {
		if(bookmark.getTitle() == null || bookmark.getTitle().length() == 0)
			addFieldError("title", getText("error.title.required"));
		if(bookmark.getUrl() == null || bookmark.getUrl().length() == 0)
			addFieldError("url",getText("error.url.required"));
		if(bookmark.getMemo() == null || bookmark.getMemo().length() == 0)
			addFieldError("memo", getText("error.memo.required"));
	}
}
